#include <WiFi.h>
//#include <WiFiClient.h>
//#include <WebServer.h>
//#include <ESPmDNS.h>
//#include <Update.h>
#include <Adafruit_DotStar.h>
#include "WS2812_Definitions.h"

const char* ssid     = " ";//your info here
const char* password = " ; //your info here
// it wil set the static IP address to 192, 168, 1, 184
IPAddress local_IP(192, 168, 1, 100);//your info here
//it wil set the gateway static IP address to 192, 168, 1,1
IPAddress gateway(192, 168, 1, 250);//your info here
// Following three settings are optional
IPAddress subnet(255, 255, 0, 0);
IPAddress primaryDNS(8, 8, 8, 8);
IPAddress secondaryDNS(8, 8, 4, 4);
WiFiServer server(80);
WiFiClient client;
unsigned char wifiTimeout = 10;

// Because conditional #includes don't work w/Arduino sketches...
#include <SPI.h>         // COMMENT OUT THIS LINE FOR GEMMA OR TRINKET
//#include <avr/power.h> // ENABLE THIS LINE FOR GEMMA OR TRINKET

#define LED_COUNT 31 // Number of LEDs in strip

// Here's how to control the LEDs from any two pins:
#define DATAPIN    13
#define CLOCKPIN   14
Adafruit_DotStar leds(LED_COUNT, DATAPIN, CLOCKPIN, DOTSTAR_BRG);
// The last parameter is optional -- this is the color data order of the
// DotStar strip, which has changed over time in different production runs.
// Your code just uses R,G,B colors, the library then reassigns as needed.
// Default is DOTSTAR_BRG, so change this if you have an earlier strip.

// Hardware SPI is a little faster, but must be wired to specific pins
// (Arduino Uno = pin 11 for data, 13 for clock, other boards are different).
//Adafruit_DotStar strip(NUMPIXELS, DOTSTAR_BRG);
#include <EEPROM.h>

#define SW1 4
#define SW2 5

#define MENURUN 0
#define MENUBRIGHTNESS 1
#define MENUANIMATION 2
#define MENUANIMATIONCOLOR 3
#define MENUSTOP 4

#define RAINBOW 0
#define RACE 1
#define FULLFADE 2
#define STARBURST 3 //boring
#define RAINBOWFADE 4
#define STOP 5

#define LIGHT 1
#define DARK 0

#define MAXBRIGHTNESS 250
#define MINBRIGHTNESS 25
#define DEBOUNCEMAX 150
#define delaySpeedMax 250
#define delaySpeedMin 50

//EEPROMClass  STATES("eeprom0", 0x500);

struct lampState {
  unsigned char brightness;
  unsigned char delaySpeed;
  unsigned char animationMode;
  unsigned long animationColor;
};

lampState defaultState = {200, 50, RAINBOWFADE, RED};
lampState runningState;

unsigned char menuState = MENURUN;
//unsigned char brightness = 125;

unsigned int menuButtonDebounceTime = DEBOUNCEMAX;
unsigned char menuButtonPressed = 0;
unsigned char menuButton = 0;

unsigned int menuSelectDebounceTime = DEBOUNCEMAX;
unsigned char menuSelectPressed = 0;
unsigned char menuSelect = 0;

unsigned char rainbowCounter = 0;

unsigned int delaySpeed = 150;
unsigned int delaySpeedCounter = delaySpeed;

//unsigned char animationMode = RAINBOW;

//unsigned long animationColor = RED;

unsigned char fadeBrightness = 0;
unsigned char fadeDirection = LIGHT;
unsigned char rainbowMode = 0;

unsigned long internalColor = RED;

unsigned int theaterJ = 0;
unsigned int theaterQ = 0;
unsigned char theaterON = 0;
unsigned int debounce = 0;
unsigned int starCounter = 50;
unsigned int starIndex = 0;

// Create an instance of the Adafruit_NeoPixel class called "leds".
// That'll be what we refer to from here on...
//Adafruit_NeoPixel leds = Adafruit_NeoPixel(LED_COUNT, LED_DATA, NEO_GRB + NEO_KHZ800);

void setup()
{
  Serial.begin(9600);
  //pinMode(POT1, INPUT);
  //pinMode(POT2, INPUT);

  EEPROM.begin(8);

  leds.begin();  // Call this to start up the LED strip.
  clearLEDs();   // This function, defined below, turns all LEDs off...
  leds.show();   // ...but the LEDs don't actually update until you call this.
  randomSeed(analogRead(0));

  runningState.animationMode = EEPROM.read(0);
  runningState.brightness = EEPROM.read(1);
  runningState.delaySpeed = EEPROM.read(2);

  Serial.println("");
  Serial.print("Brightness: ");
  Serial.println(runningState.brightness);
  Serial.print("Speed ");
  Serial.println(runningState.delaySpeed);
  Serial.print("Mode ");
  Serial.println(runningState.animationMode);
  Serial.print("Color ");
  Serial.println(runningState.animationColor);

  //EEPROM.get(0, runningState);
  if (runningState.brightness  < MINBRIGHTNESS) {
    defaultState.animationColor = getRandomColor(0);
    runningState.brightness = defaultState.brightness;
    runningState.delaySpeed = defaultState.delaySpeed;
    runningState.animationMode = defaultState.animationMode;
    runningState.animationColor = defaultState.animationColor;
    EEPROM.write(0, runningState.animationMode);
    EEPROM.write(1, runningState.brightness);
    EEPROM.write(2, runningState.delaySpeed);
    EEPROM.commit();

    Serial.println("");
    Serial.print("Brightness: ");
    Serial.println(runningState.brightness);
    Serial.print("Speed ");
    Serial.println(runningState.delaySpeed);
    Serial.print("Mode ");
    Serial.println(runningState.animationMode);
    Serial.print("Color ");
    Serial.println(runningState.animationColor);
  }

  // This part of code will try create static IP address
  if (!WiFi.config(local_IP, gateway, subnet, primaryDNS, secondaryDNS)) {
    Serial.println("STA Failed to configure");
  }

  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED && wifiTimeout) {
    delay(500);
    if (wifiTimeout)
      wifiTimeout--;
  }
  server.begin();
  Serial.println("boot");
}

void loop()
{
  if (wifiTimeout) {
    WiFiClient client = server.available();   // listen for incoming clients

    if (client) {                             // if you get a client,
      String req = client.readStringUntil('\r');
      client.flush();
      if (!debounce) {
        debounce = 350;
        Serial.println("hit");
        if (req.indexOf("/mode/0") != -1) {
          runningState.animationMode = RAINBOW;
        }
        else if (req.indexOf("/mode/1") != -1) {
          runningState.animationMode = RACE;
        }
        else if (req.indexOf("/mode/2") != -1) {
          runningState.animationMode = FULLFADE;
        }
        else if (req.indexOf("/mode/3") != -1) {
          runningState.animationMode = STARBURST;
        }
        else if (req.indexOf("/mode/4") != -1) {
          runningState.animationMode = RAINBOWFADE;
        }
        else if (req.indexOf("/mode/5") != -1) {
          runningState.animationMode = STOP;
        }
        else if (req.indexOf("/brightness/up") != -1) {
          if (runningState.brightness < MAXBRIGHTNESS)
            runningState.brightness += 25;
          if (runningState.brightness > MAXBRIGHTNESS)
            runningState.brightness = MAXBRIGHTNESS;
          leds.setBrightness(runningState.brightness);
        }
        else if (req.indexOf("/brightness/down") != -1) {
          if (runningState.brightness > MINBRIGHTNESS)
            runningState.brightness -= 25;
          if (runningState.brightness < MINBRIGHTNESS)
            runningState.brightness = MINBRIGHTNESS;
          leds.setBrightness(runningState.brightness);
        }
        else if (req.indexOf("/speed/up") != -1) {
          if (runningState.delaySpeed > delaySpeedMin)
            runningState.delaySpeed -= 25;
          if (runningState.delaySpeed < delaySpeedMin)
            runningState.delaySpeed = delaySpeedMin;
        }
        else if (req.indexOf("/speed/down") != -1) {
          if (runningState.delaySpeed < delaySpeedMax)
            runningState.delaySpeed += 25;
          if (runningState.delaySpeed > delaySpeedMax)
            runningState.delaySpeed = delaySpeedMax;
        }
        EEPROMUpdate();
      }
    }
  }
  if (delaySpeedCounter)
    delaySpeedCounter--;
  else {
    delaySpeedCounter = runningState.delaySpeed;

    switch (runningState.animationMode) {
      case RAINBOW:
        doRainbow();
        break;

      case RACE:
        rainbowMode = 1;
        doRace();
        break;

      case FULLFADE:
        //rainbowMode = 1;
        theaterChaseRainbow();
        break;

      case STARBURST:
        doStarBurst();
        break;

      case RAINBOWFADE:
        rainbowMode = 1;
        doFade();
        break;

      case STOP:
        clearLEDs();
        break;

      default:
        break;
    }
  }
  if (debounce)
    debounce--;
  leds.show();   // ...but the LEDs don't actually update until you call this.

  /*
    // Indigo cylon
    // Do a cylon (larson scanner) cycle 10 times
    for (int i=0; i<10; i++)
    {
    // cylon function: first param is color, second is time (in ms) between cycles
    cylon(INDIGO, 500);  // Indigo cylon eye!
    }
  */
  /*
    // A light shower of spring green rain
    // This will run the cascade from top->bottom 20 times
    for (int i=0; i<20; i++)
    {
    // First parameter is the color, second is direction, third is ms between falls
    cascade(MEDIUMSPRINGGREEN, TOP_DOWN, 100);
    }
  */
}

void EEPROMUpdate() {
  //unsigned char animationMode; 0
  //unsigned char brightness; 1
  //unsigned char delaySpeed; 2
  unsigned char readValue;

  readValue = EEPROM.read(0);
  if (readValue != runningState.animationMode) {
    EEPROM.write(0, runningState.animationMode);
    EEPROM.commit();
    Serial.println("");
    Serial.print("AnimationMode: ");
    Serial.println(runningState.animationMode);
  }
  readValue = EEPROM.read(1);
  if (readValue != runningState.brightness) {
    EEPROM.write(1, runningState.brightness);
    EEPROM.commit();
    Serial.println("");
    Serial.print("Brightness: ");
    Serial.println(runningState.brightness);
  }

  readValue = EEPROM.read(2);
  if (readValue != runningState.delaySpeed) {
    EEPROM.write(2, runningState.delaySpeed);
    EEPROM.commit();
    Serial.println("");
    Serial.print("Speed: ");
    Serial.println(runningState.delaySpeed);
  }
}

void doStarBurst() {
  if (starCounter)
    starCounter--;
  else {
    switch (starIndex) {
      case 0:
        clearLEDs();
        leds.setPixelColor(0, internalColor);
        starIndex++;
        starCounter = 7;
        break;

      case 1:
        clearLEDs();
        leds.setPixelColor(1, internalColor);
        leds.setPixelColor(5, internalColor);
        leds.setPixelColor(7, internalColor);
        leds.setPixelColor(11, internalColor);
        leds.setPixelColor(13, internalColor);
        leds.setPixelColor(17, internalColor);
        leds.setPixelColor(19, internalColor);
        leds.setPixelColor(23, internalColor);
        leds.setPixelColor(25, internalColor);
        leds.setPixelColor(29, internalColor);
        starIndex++;
        starCounter = 5;
        break;

      case 2:
        clearLEDs();
        leds.setPixelColor(2, internalColor);
        leds.setPixelColor(6, internalColor);
        leds.setPixelColor(8, internalColor);
        leds.setPixelColor(12, internalColor);
        leds.setPixelColor(14, internalColor);
        leds.setPixelColor(18, internalColor);
        leds.setPixelColor(20, internalColor);
        leds.setPixelColor(24, internalColor);
        leds.setPixelColor(26, internalColor);
        leds.setPixelColor(30, internalColor);
        starIndex++;
        starCounter = 3;
        break;

      case 3:
        clearLEDs();
        leds.setPixelColor(3, internalColor);
        leds.setPixelColor(9, internalColor);
        leds.setPixelColor(15, internalColor);
        leds.setPixelColor(21, internalColor);
        leds.setPixelColor(27, internalColor);
        starIndex++;
        starCounter = 2;
        break;

      case 4:
        clearLEDs();
        leds.setPixelColor(4, internalColor);
        leds.setPixelColor(10, internalColor);
        leds.setPixelColor(16, internalColor);
        leds.setPixelColor(22, internalColor);
        leds.setPixelColor(28, internalColor);
        starIndex++;
        starCounter = 10;
        break;

      case 5:
        clearLEDs();
        internalColor = getRandomColor(internalColor);
        starIndex = 0;
        break;

      default:
        starIndex = 0;
        break;
    }
    //Serial.print("starcount ");
    //Serial.println(starIndex);
    //starCounter = 10;
  }
}

void doRainbow() {
  if (rainbowCounter < 10 * LED_COUNT)
    rainbowCounter++;
  else
    rainbowCounter = 0;
  rainbow(rainbowCounter);
}

void doRace() {

  if (rainbowCounter < LED_COUNT - 1)
    rainbowCounter++;
  else {
    if (rainbowMode)
      internalColor = getRandomColor(internalColor);
    else
      internalColor = runningState.animationColor;

    rainbowCounter = 0;
  }
  race(internalColor, rainbowCounter);
}

void doFade() {
  unsigned char brightStep = runningState.brightness / 25;

  if (fadeDirection == LIGHT) {
    if (fadeBrightness < runningState.brightness - brightStep)
      fadeBrightness += brightStep;
    else {
      fadeBrightness = runningState.brightness;
      fadeDirection = DARK;
    }
  }
  else {
    if (fadeBrightness > brightStep)
      fadeBrightness -= brightStep;
    else {
      fadeBrightness = 0;
      fadeDirection = LIGHT;
      if (rainbowMode)
        internalColor = getRandomColor(internalColor);
      else
        internalColor = runningState.animationColor;
    }
  }

  for (int i = 0; i < LED_COUNT; i++) {
    leds.setPixelColor(i, internalColor);
  }
  leds.setBrightness(fadeBrightness);
}

void race (unsigned long color, unsigned char pixel) {
  byte red = (color & 0xFF0000) >> 16;
  byte green = (color & 0x00FF00) >> 8;
  byte blue = (color & 0x0000FF);
  //clearLEDs();
  leds.setPixelColor(pixel, red, green, blue);
}

// Sets all LEDs to off, but DOES NOT update the display;
// call leds.show() to actually turn them off after this.
void clearLEDs()
{
  for (int i = 0; i < LED_COUNT; i++)
  {
    leds.setPixelColor(i, 0);
  }
}

// Prints a rainbow on the ENTIRE LED strip.
//  The rainbow begins at a specified position.
// ROY G BIV!
void rainbow(byte startPosition)
{
  // Need to scale our rainbow. We want a variety of colors, even if there
  // are just 10 or so pixels.
  int rainbowScale = 192 / LED_COUNT;

  // Next we setup each pixel with the right color
  for (int i = 0; i < LED_COUNT; i++)
  {
    // There are 192 total colors we can get out of the rainbowOrder function.
    // It'll return a color between red->orange->green->...->violet for 0-191.
    leds.setPixelColor(i, rainbowOrder((rainbowScale * (i + startPosition)) % 192));
  }
  // Finally, actually turn the LEDs on:
  //leds.show();
}

// Input a value 0 to 191 to get a color value.
// The colors are a transition red->yellow->green->aqua->blue->fuchsia->red...
//  Adapted from Wheel function in the Adafruit_NeoPixel library example sketch
uint32_t rainbowOrder(byte position)
{
  // 6 total zones of color change:
  if (position < 31)  // Red -> Yellow (Red = FF, blue = 0, green goes 00-FF)
  {
    return leds.Color(0xFF, position * 8, 0);
  }
  else if (position < 63)  // Yellow -> Green (Green = FF, blue = 0, red goes FF->00)
  {
    position -= 31;
    return leds.Color(0xFF - position * 8, 0xFF, 0);
  }
  else if (position < 95)  // Green->Aqua (Green = FF, red = 0, blue goes 00->FF)
  {
    position -= 63;
    return leds.Color(0, 0xFF, position * 8);
  }
  else if (position < 127)  // Aqua->Blue (Blue = FF, red = 0, green goes FF->00)
  {
    position -= 95;
    return leds.Color(0, 0xFF - position * 8, 0xFF);
  }
  else if (position < 159)  // Blue->Fuchsia (Blue = FF, green = 0, red goes 00->FF)
  {
    position -= 127;
    return leds.Color(position * 8, 0, 0xFF);
  }
  else  //160 <position< 191   Fuchsia->Red (Red = FF, green = 0, blue goes FF->00)
  {
    position -= 159;
    return leds.Color(0xFF, 0x00, 0xFF - position * 8);
  }
}

uint32_t getRandomColor(uint32_t oldColor) {
  uint32_t tempColor = oldColor;
  tempColor = Wheel(random(255));
  while (tempColor == oldColor) {
    tempColor = Wheel(random(255));
  }
  return tempColor;
}

//Theatre-style crawling lights with rainbow effect
void theaterChaseRainbow() {
  /*
    }
    if (theaterON) {

    for (int i = 1; i < LED_COUNT; i += 2) {
      leds.setPixelColor(i, Wheel( (i + theaterJ) % 255)); //turn every third pixel on
    }
    //leds.setPixelColor(0, 0);      //turn every third pixel off
    //leds.setPixelColor(2, 0);      //turn every third pixel off
    //leds.setPixelColor(4, 0);      //turn every third pixel off
    //leds.setPixelColor(1, Wheel( (1 + theaterJ) % 255)); //turn every third pixel on
    //leds.setPixelColor(3, Wheel( (3 + theaterJ) % 255)); //turn every third pixel on
    theaterON = 0;
    }
    else {
    for (int i = 0; i < LED_COUNT; i += 2) {
      leds.setPixelColor(i, Wheel( (i + theaterJ) % 255)); //turn every third pixel on
    }
    //leds.setPixelColor(1, 0);      //turn every third pixel off
    //leds.setPixelColor(3, 0);      //turn every third pixel off
    //leds.setPixelColor(0, Wheel( (0 + theaterJ) % 255)); //turn every third pixel on
    //leds.setPixelColor(2, Wheel( (2 + theaterJ) % 255)); //turn every third pixel on
    //leds.setPixelColor(4, Wheel( (4 + theaterJ) % 255)); //turn every third pixel on
    theaterON = 1;
    }
  */

  for (int i = 0; i < LED_COUNT; i++) {
    leds.setPixelColor(i, Wheel( (i + theaterJ) % 255));
  }

  if (theaterJ < 255)
    theaterJ++;
  else
    theaterJ = 0;
}

// Input a value 0 to 255 to get a color value.
// The colours are a transition r - g - b - back to r.
uint32_t Wheel(byte WheelPos)
{
  WheelPos = 255 - WheelPos;
  if (WheelPos < 85)
  {
    return leds.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  }
  else if (WheelPos < 170)
  {
    WheelPos -= 85;
    return leds.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  }
  else
  {
    WheelPos -= 170;
    return leds.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
  }
}
